RTEMS: Message Queue Handler

| RTEMS 5.4-rc2

Loading...
Searching...
No Matches
Files | Data Structures | Macros | Typedefs | Enumerations | Functions
Message Queue Handler
Internal » SuperCore

Message Queue Handler. More...

## Files
file | coremsg.h
| Constants and Structures Associated with the Message Queue Handler.
file | coremsgimpl.h
| Inlined Routines in the Core Message Handler.
file | coremsg.c
| Initialize a Message Queue.
file | coremsgbroadcast.c
| Broadcast a Message to the Message Queue.
file | coremsgclose.c
| Close a Message Queue.
file | coremsgflush.c
| Flush Messages Routine.
file | coremsgflushwait.c
| Flush Waiting Threads.
file | coremsginsert.c
| Insert a Message into the Message Queue.
file | coremsgseize.c
| Seize a Message from the Message Queue.
file | coremsgsubmit.c
| CORE Message Queue Submit.

## Data Structures
struct | CORE_message_queue_Buffer
| Data types needed to manipulate the contents of message buffers. More...
struct | CORE_message_queue_Buffer_control
| The organization of a message buffer. More...
struct | CORE_message_queue_Control
| Control block used to manage each message queue. More...

## Macros
#define | RTEMS_SCORE_COREMSG_ENABLE_MESSAGE_PRIORITY
#define | RTEMS_SCORE_COREMSG_ENABLE_BLOCKING_SEND
#define | CORE_MESSAGE_QUEUE_SEND_REQUEST INT_MAX
| Used when appending messages onto a message queue.
#define | CORE_MESSAGE_QUEUE_URGENT_REQUEST INT_MIN
| Used when prepending messages onto a message queue.
#define | _CORE_message_queue_Set_notify(the_message_queue, the_handler) do { } while ( 0 )
| Initializes notification information.

## Typedefs
typedef struct CORE_message_queue_Control | CORE_message_queue_Control
typedef int | CORE_message_queue_Submit_types
| The modes in which a message may be submitted to a message queue.

## Enumerations
enum | CORE_message_queue_Disciplines { CORE_MESSAGE_QUEUE_DISCIPLINES_FIFO , CORE_MESSAGE_QUEUE_DISCIPLINES_PRIORITY }
| The possible blocking disciplines for a message queue. More...

## Functions
bool | _CORE_message_queue_Initialize (CORE_message_queue_Control *the_message_queue, CORE_message_queue_Disciplines discipline, uint32_t maximum_pending_messages, size_t maximum_message_size)
| Initializes a message queue.
void | _CORE_message_queue_Close (CORE_message_queue_Control *the_message_queue, Thread_queue_Context *queue_context)
| Closes a message queue.
uint32_t | _CORE_message_queue_Flush (CORE_message_queue_Control *the_message_queue, Thread_queue_Context *queue_context)
| Flushes pending messages.
Status_Control | _CORE_message_queue_Broadcast (CORE_message_queue_Control *the_message_queue, const void *buffer, size_t size, uint32_t *count, Thread_queue_Context *queue_context)
| Broadcasts a message to the message queue.
Status_Control | _CORE_message_queue_Submit (CORE_message_queue_Control *the_message_queue, Thread_Control *executing, const void *buffer, size_t size, CORE_message_queue_Submit_types submit_type, bool wait, Thread_queue_Context *queue_context)
| Submits a message to the message queue.
Status_Control | _CORE_message_queue_Seize (CORE_message_queue_Control *the_message_queue, Thread_Control *executing, void *buffer, size_t *size_p, bool wait, Thread_queue_Context *queue_context)
| Seizes a message from the message queue.
void | _CORE_message_queue_Insert_message (CORE_message_queue_Control *the_message_queue, CORE_message_queue_Buffer_control *the_message, const void *content_source, size_t content_size, CORE_message_queue_Submit_types submit_type)
| Inserts a message into the message queue.
RTEMS_INLINE_ROUTINE Status_Control | _CORE_message_queue_Send (CORE_message_queue_Control *the_message_queue, const void *buffer, size_t size, bool wait, Thread_queue_Context *queue_context)
| Sends a message to the message queue.
RTEMS_INLINE_ROUTINE Status_Control | _CORE_message_queue_Urgent (CORE_message_queue_Control *the_message_queue, const void *buffer, size_t size, bool wait, Thread_queue_Context *queue_context)
| Sends an urgent message to the message queue.
RTEMS_INLINE_ROUTINE void | _CORE_message_queue_Acquire (CORE_message_queue_Control *the_message_queue, Thread_queue_Context *queue_context)
| Acquires the message queue.
RTEMS_INLINE_ROUTINE void | _CORE_message_queue_Acquire_critical (CORE_message_queue_Control *the_message_queue, Thread_queue_Context *queue_context)
| Acquires the message queue critical.
RTEMS_INLINE_ROUTINE void | _CORE_message_queue_Release (CORE_message_queue_Control *the_message_queue, Thread_queue_Context *queue_context)
| Releases the message queue.
RTEMS_INLINE_ROUTINE void | _CORE_message_queue_Copy_buffer (const void *source, void *destination, size_t size)
| Copies the source message buffer to the destination message buffer.
RTEMS_INLINE_ROUTINE CORE_message_queue_Buffer_control * | _CORE_message_queue_Allocate_message_buffer (CORE_message_queue_Control *the_message_queue)
| Allocates a message buffer from the inactive message buffer chain.
RTEMS_INLINE_ROUTINE void | _CORE_message_queue_Free_message_buffer (CORE_message_queue_Control *the_message_queue, CORE_message_queue_Buffer_control *the_message)
| Frees a message buffer to inactive message buffer chain.
RTEMS_INLINE_ROUTINE int | _CORE_message_queue_Get_message_priority (const CORE_message_queue_Buffer_control *the_message)
| Gets message priority.
RTEMS_INLINE_ROUTINE CORE_message_queue_Buffer_control * | _CORE_message_queue_Get_pending_message (CORE_message_queue_Control *the_message_queue)
| Gets first message of message queue and removes it.
RTEMS_INLINE_ROUTINE Thread_Control * | _CORE_message_queue_Dequeue_receiver (CORE_message_queue_Control *the_message_queue, const void *buffer, size_t size, CORE_message_queue_Submit_types submit_type, Thread_queue_Context *queue_context)
| Gets the first locked thread waiting to receive and dequeues it.

## Detailed Description

Message Queue Handler.

This handler encapsulates functionality which provides the foundation Message Queue services used in all of the APIs supported by RTEMS.

## Macro Definition Documentation

## ◆ _CORE_message_queue_Set_notify

#define _CORE_message_queue_Set_notify | ( |  | the_message_queue,
|  |  | the_handler
| ) |  | do { } while ( 0 )

Initializes notification information.

This routine initializes the notification information for the_message_queue.

Parameters

  [out] | the_message_queue | The message queue to initialize the notification information.
  [out] | the_handler | The notification information for the message queue.

## ◆ CORE_MESSAGE_QUEUE_SEND_REQUEST

#define CORE_MESSAGE_QUEUE_SEND_REQUEST INT_MAX

Used when appending messages onto a message queue.

This is the priority constant used when appending messages onto a message queue.

## ◆ CORE_MESSAGE_QUEUE_URGENT_REQUEST

#define CORE_MESSAGE_QUEUE_URGENT_REQUEST INT_MIN

Used when prepending messages onto a message queue.

This is the priority constant used when prepending messages onto a message queue.

## ◆ RTEMS_SCORE_COREMSG_ENABLE_BLOCKING_SEND

#define RTEMS_SCORE_COREMSG_ENABLE_BLOCKING_SEND

This macro is defined when an API is enabled that requires the Message Queue Handler include support for blocking send operations.

## ◆ RTEMS_SCORE_COREMSG_ENABLE_MESSAGE_PRIORITY

#define RTEMS_SCORE_COREMSG_ENABLE_MESSAGE_PRIORITY

This macro is defined when an API is enabled that requires that the Message Queue Handler include support for priority based enqueuing of messages.

## Typedef Documentation

## ◆ CORE_message_queue_Submit_types

typedef int CORE_message_queue_Submit_types

The modes in which a message may be submitted to a message queue.

The following type details the modes in which a message may be submitted to a message queue. The message may be posted in a send or urgent fashion.

Note
  All other values are message priorities. Numerically smaller priorities indicate higher priority messages.

## Enumeration Type Documentation

## ◆ CORE_message_queue_Disciplines

enum CORE_message_queue_Disciplines

The possible blocking disciplines for a message queue.

This enumerated types defines the possible blocking disciplines for a message queue.

Enumerator
CORE_MESSAGE_QUEUE_DISCIPLINES_FIFO | This value indicates that blocking tasks are in FIFO order.
CORE_MESSAGE_QUEUE_DISCIPLINES_PRIORITY | This value indicates that blocking tasks are in priority order.

## Function Documentation

## ◆ _CORE_message_queue_Acquire()

RTEMS_INLINE_ROUTINE void _CORE_message_queue_Acquire | ( | CORE_message_queue_Control * | the_message_queue,
|  | Thread_queue_Context * | queue_context
| ) |  |

Acquires the message queue.

Parameters

  [in,out] | the_message_queue | Rhe message queue to acquire.
  | queue_context | The thread queue context.

## ◆ _CORE_message_queue_Acquire_critical()

RTEMS_INLINE_ROUTINE void _CORE_message_queue_Acquire_critical | ( | CORE_message_queue_Control * | the_message_queue,
|  | Thread_queue_Context * | queue_context
| ) |  |

Acquires the message queue critical.

Parameters

  [in,out] | the_message_queue | The message queue to acquire critical.
  | queue_context | The thread queue context.

## ◆ _CORE_message_queue_Allocate_message_buffer()

RTEMS_INLINE_ROUTINE CORE_message_queue_Buffer_control * _CORE_message_queue_Allocate_message_buffer | ( | CORE_message_queue_Control * | the_message_queue | ) |

Allocates a message buffer from the inactive message buffer chain.

This function allocates a message buffer from the inactive message buffer chain.

Parameters

  the_message_queue | The message queue to operate upon.

Return values

  pointer | The allocated message buffer.
  NULL | The inactive message buffer chain is empty.

## ◆ _CORE_message_queue_Broadcast()

Status_Control _CORE_message_queue_Broadcast | ( | CORE_message_queue_Control * | the_message_queue,
|  | const void * | buffer,
|  | size_t | size,
|  | uint32_t * | count,
|  | Thread_queue_Context * | queue_context
| ) |  |

Broadcasts a message to the message queue.

This package is the implementation of the CORE Message Queue Handler. This core object provides task synchronization and communication functions via messages passed to queue objects.

This function sends a message for every thread waiting on the queue and returns the number of threads made ready by the message.

Parameters

  [in,out] | the_message_queue | The message queue to operate upon.
  | buffer | The starting address of the message to broadcast.
  | size | The size of the message being broadcast.
  [out] | count | The variable that will contain the number of tasks that are sent this message.
  | queue_context | The thread queue context used for _CORE_message_queue_Acquire() or _CORE_message_queue_Acquire_critical().

Return values

  STATUS_SUCCESSFUL | The message was successfully broadcast.
  STATUS_MESSAGE_INVALID_SIZE | The message size was too big.

## ◆ _CORE_message_queue_Close()

void _CORE_message_queue_Close | ( | CORE_message_queue_Control * | the_message_queue,
|  | Thread_queue_Context * | queue_context
| ) |  |

Closes a message queue.

This package is the implementation of the CORE Message Queue Handler. This core object provides task synchronization and communication functions via messages passed to queue objects.

This function closes a message by returning all allocated space and flushing the_message_queue's task wait queue.

Parameters

  [in,out] | the_message_queue | The message queue to close.
  [in,out] | queue_context | The thread queue context used for _CORE_message_queue_Acquire() or _CORE_message_queue_Acquire_critical().

## ◆ _CORE_message_queue_Copy_buffer()

RTEMS_INLINE_ROUTINE void _CORE_message_queue_Copy_buffer | ( | const void * | source,
|  | void * | destination,
|  | size_t | size
| ) |  |

Copies the source message buffer to the destination message buffer.

This routine copies the contents of the source message buffer to the destination message buffer.

Parameters

  | source | The source message buffer to be copied.
  [out] | destination | The destination messag buffer to copy the source to.
  | size | The size of the source buffer.

## ◆ _CORE_message_queue_Dequeue_receiver()

RTEMS_INLINE_ROUTINE Thread_Control * _CORE_message_queue_Dequeue_receiver | ( | CORE_message_queue_Control * | the_message_queue,
|  | const void * | buffer,
|  | size_t | size,
|  | CORE_message_queue_Submit_types | submit_type,
|  | Thread_queue_Context * | queue_context
| ) |  |

Gets the first locked thread waiting to receive and dequeues it.

This method dequeues the first locked thread waiting to receive a message, dequeues it and returns the corresponding Thread_Control.

Parameters

  [in,out] | the_message_queue | The message queue to operate upon.
  | buffer | The buffer that is copied to the threads mutable_object.
  | size | The size of the buffer.
  | submit_type | Indicates whether the thread should be willing to block in the future.
  | queue_context | The thread queue context.

Return values

  thread | The Thread_Control for the first locked thread, if there is a locked thread.
  NULL | There are pending messages or no thread waiting to receive.

## ◆ _CORE_message_queue_Flush()

uint32_t _CORE_message_queue_Flush | ( | CORE_message_queue_Control * | the_message_queue,
|  | Thread_queue_Context * | queue_context
| ) |  |

Flushes pending messages.

This package is the implementation of the CORE Message Queue Handler. This core object provides task synchronization and communication functions via messages passed to queue objects.

This function flushes the_message_queue's pending message queue. The number of messages flushed from the queue is returned.

Parameters

  [in,out] | the_message_queue | The message queue to flush.
  | queue_context | The thread queue context with interrupts disabled.

Returns
  This method returns the number of message pending messages flushed.

## ◆ _CORE_message_queue_Free_message_buffer()

RTEMS_INLINE_ROUTINE void _CORE_message_queue_Free_message_buffer | ( | CORE_message_queue_Control * | the_message_queue,
|  | CORE_message_queue_Buffer_control * | the_message
| ) |  |

Frees a message buffer to inactive message buffer chain.

This routine frees a message buffer to the inactive message buffer chain.

Parameters

  [in,out] | the_message_queue | The message queue to free the message buffer to.
  [out] | the_message | The message to be freed.

## ◆ _CORE_message_queue_Get_message_priority()

RTEMS_INLINE_ROUTINE int _CORE_message_queue_Get_message_priority | ( | const CORE_message_queue_Buffer_control * | the_message | ) |

Gets message priority.

This function returns the priority of the_message.

Parameters

  the_message | The message to obtain the priority from.

Return values

  priority | The priority of this message.
  0 | Message priority is disabled.

Note
  It encapsulates the optional behavior that message priority is disabled if no API requires it.

## ◆ _CORE_message_queue_Get_pending_message()

RTEMS_INLINE_ROUTINE CORE_message_queue_Buffer_control * _CORE_message_queue_Get_pending_message | ( | CORE_message_queue_Control * | the_message_queue | ) |

Gets first message of message queue and removes it.

This function removes the first message from the_message_queue and returns a pointer to it.

Parameters

  [in,out] | the_message_queue | The message queue to get the first message from.

Return values

  pointer | The first message if the message queue is not empty.
  NULL | The message queue is empty.

## ◆ _CORE_message_queue_Initialize()

bool _CORE_message_queue_Initialize | ( | CORE_message_queue_Control * | the_message_queue,
|  | CORE_message_queue_Disciplines | discipline,
|  | uint32_t | maximum_pending_messages,
|  | size_t | maximum_message_size
| ) |  |

Initializes a message queue.

This package is the implementation of the CORE Message Queue Handler. This core object provides task synchronization and communication functions via messages passed to queue objects.

This routine initializes the_message_queue based on the parameters passed.

Parameters

  [out] | the_message_queue | The message queue to initialize.
  | discipline | The blocking discipline for the message queue.
  | maximum_pending_messages | The maximum number of messages that will be allowed to pend at any given time.
  | maximum_message_size | The size of the largest message that may be sent to this message queue instance.

Return values

  true | The message queue can be initialized.
  false | Memory for the pending messages cannot be allocated.

## ◆ _CORE_message_queue_Insert_message()

void _CORE_message_queue_Insert_message | ( | CORE_message_queue_Control * | the_message_queue,
|  | CORE_message_queue_Buffer_control * | the_message,
|  | const void * | content_source,
|  | size_t | content_size,
|  | CORE_message_queue_Submit_types | submit_type
| ) |  |

Inserts a message into the message queue.

Copies the specified content into the message storage space and then inserts the message into the message queue according to the submit type.

Parameters

  [in,out] | the_message_queue | The message queue to insert a message in.
  [in,out] | the_message | The message to insert in the message queue.
  | content_source | The message content source.
  | content_size | The message content size in bytes.
  | submit_type | Determines whether the message is prepended, appended, or enqueued in priority order.

## ◆ _CORE_message_queue_Release()

RTEMS_INLINE_ROUTINE void _CORE_message_queue_Release | ( | CORE_message_queue_Control * | the_message_queue,
|  | Thread_queue_Context * | queue_context
| ) |  |

Releases the message queue.

Parameters

  [in,out] | the_message_queue | The message queue to release.
  | queue_context | The thread queue context.

## ◆ _CORE_message_queue_Seize()

Status_Control _CORE_message_queue_Seize | ( | CORE_message_queue_Control * | the_message_queue,
|  | Thread_Control * | executing,
|  | void * | buffer,
|  | size_t * | size_p,
|  | bool | wait,
|  | Thread_queue_Context * | queue_context
| ) |  |

Seizes a message from the message queue.

This package is the implementation of the CORE Message Queue Handler. This core object provides task synchronization and communication functions via messages passed to queue objects.

This kernel routine dequeues a message, copies the message buffer to a given destination buffer, and frees the message buffer to the inactive message pool. The thread will be blocked if wait is true, otherwise an error will be given to the thread if no messages are available.

Parameters

  [in,out] | the_message_queue | The message queue to seize a message from.
  | executing | The executing thread.
  [out] | buffer | The starting address of the message buffer to to be filled in with a message.
  [out] | size_p | The size of the buffer, indicates the maximum size message that the caller can receive.
  | wait | Indicates whether the calling thread is willing to block if the message queue is empty.
  | queue_context | The thread queue context used for _CORE_message_queue_Acquire() or _CORE_message_queue_Acquire_critical().

Return values

  STATUS_SUCCESSFUL | The message was successfully seized from the message queue.
  STATUS_UNSATISFIED | Wait was set to false and there is currently no pending message.
  STATUS_TIMEOUT | A timeout occured.

Note
  Returns message priority via return area in TCB.

- INTERRUPT LATENCY:
  - available
  - wait

## ◆ _CORE_message_queue_Send()

RTEMS_INLINE_ROUTINE Status_Control _CORE_message_queue_Send | ( | CORE_message_queue_Control * | the_message_queue,
|  | const void * | buffer,
|  | size_t | size,
|  | bool | wait,
|  | Thread_queue_Context * | queue_context
| ) |  |

Sends a message to the message queue.

Parameters

  [in,out] | the_message_queue | The message queue to send a message to.
  | buffer | The starting address of the message to send.
  | sizeis | The size of the message being send.
  | wait | Indicates whether the calling thread is willing to block if the message queue is full.
  | queue_context | The thread queue context used for _CORE_message_queue_Acquire() or _CORE_message_queue_Acquire_critical().

Return values

  STATUS_SUCCESSFUL | The message was successfully submitted to the message queue.
  STATUS_MESSAGE_INVALID_SIZE | The message size was too big.
  STATUS_TOO_MANY | No message buffers were available.
  STATUS_MESSAGE_QUEUE_WAIT_IN_ISR | The caller is in an ISR, do not block!
  STATUS_TIMEOUT | A timeout occured.

## ◆ _CORE_message_queue_Submit()

Status_Control _CORE_message_queue_Submit | ( | CORE_message_queue_Control * | the_message_queue,
|  | Thread_Control * | executing,
|  | const void * | buffer,
|  | size_t | size,
|  | CORE_message_queue_Submit_types | submit_type,
|  | bool | wait,
|  | Thread_queue_Context * | queue_context
| ) |  |

Submits a message to the message queue.

This routine implements the send and urgent message functions. It processes a message that is to be submitted to the designated message queue. The message will either be processed as a send message which it will be inserted at the rear of the queue or it will be processed as an urgent message which will be inserted at the front of the queue.

Parameters

  [in,out] | the_message_queue | The message queue to operate upon.
  | executing | The executing thread.
  | buffer | The starting address of the message to send.
  | size | The size of the message being send.
  | submit_type | Determines whether the message is prepended, appended, or enqueued in priority order.
  | wait | Indicates whether the calling thread is willing to block if the message queue is full.
  | queue_context | The thread queue context used for _CORE_message_queue_Acquire() or _CORE_message_queue_Acquire_critical().

Return values

  STATUS_SUCCESSFUL | The message was successfully submitted to the message queue.
  STATUS_MESSAGE_INVALID_SIZE | The message size was too big.
  STATUS_TOO_MANY | No message buffers were available.
  STATUS_MESSAGE_QUEUE_WAIT_IN_ISR | The caller is in an ISR, do not block!
  STATUS_TIMEOUT | A timeout occured.

## ◆ _CORE_message_queue_Urgent()

RTEMS_INLINE_ROUTINE Status_Control _CORE_message_queue_Urgent | ( | CORE_message_queue_Control * | the_message_queue,
|  | const void * | buffer,
|  | size_t | size,
|  | bool | wait,
|  | Thread_queue_Context * | queue_context
| ) |  |

Sends an urgent message to the message queue.

Parameters

  [in,out] | the_message_queue | The message queue to send an urgent message to.
  | buffer | The starting address of the message to send.
  | sizeis | The size of the message being send.
  | wait | Indicates whether the calling thread is willing to block if the message queue is full.
  | queue_context | The thread queue context used for _CORE_message_queue_Acquire() or _CORE_message_queue_Acquire_critical().

Return values

  STATUS_SUCCESSFUL | The message was successfully submitted to the message queue.
  STATUS_MESSAGE_INVALID_SIZE | The message size was too big.
  STATUS_TOO_MANY | No message buffers were available.
  STATUS_MESSAGE_QUEUE_WAIT_IN_ISR | The caller is in an ISR, do not block!
  STATUS_TIMEOUT | A timeout occured.